#!/usr/bin/perl
#
# (c) Gnther Alka 2022

# script to decrypt/automount filesystems with enc:automount=yes and keysplit =..:..
# initiated by bootinit.pl
# 16.dec 2021, remenber smb settings like abe
# 17. aug 2022 skip snaps line 52
# 22. aug, more debug info via  # perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent-bootunlock.pl

use strict;
use vars qw(@tt @al $par $date_ymd %sys $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t @t $f @f %data $D %p %cfg %in @p @w $r);

#load lib
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/zfslib.pl";
require  "/var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent_autolock.lib";
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/keyserverlib.pl";

#os
$t=`uname -a`;
@t=split(/ /,$t);
if ($t[3]=~/^11/)      {                                                                         # Oracle Solaris
   $sys{'auto_os'}="Solaris 11";
   $sys{'auto_os_type'}="sol_s";
   $sys{'auto_os_ver'}=$t[3];
}

$par=$ARGV[0];
if (!(defined($par))) { $par="-"; }


use lib "/var/web-gui/data/napp-it/CGI";
use Expect;   # for unlocking

#Debug=0/1
$D="0";
if ($par=~/d/i) { $D="1"; }

#read config
       @t=();
       open (F,"</var/web-gui/_log/napp-it.cfg");
             @t=<F>;
       close (F);
       foreach my $t (@t) {    #
           @w=();
           @w=split(/\|/,$t);
           #print "$w[0] => $w[1]\n";
           if ($w[0]=~/\w/) { $cfg{$w[0]}=$w[1];   }
       }


$t=`/sbin/zfs get all | grep enc_automount: | grep -v % | grep -v @ `;     # name   enc_automount:     yes   local

@tt=split(/\n/,$t);
$t=~s/ +/, /gs;
print ">list enc filesystems\n$t\n\n";

foreach my $t (@tt) {

     @w=split(/ +/,$t);

     if ($w[2] eq "yes") {
         $f=`/sbin/zfs get all $w[0] | grep enc_split: | grep -v % | grep 1:`;
         print "process fs with yeautomount yes: $f";

         if ($sys{'auto_os'} eq "Solaris 11") {
            $r=`/sbin/zfs get -H -o value keysource $w[0]`;  chomp($r);
         } else {
            $r=`/sbin/zfs get -H -o value keyformat $w[0]`;  chomp($r);
            $r.=','.`/sbin/zfs get -H -o value keylocation $w[0]`;  chomp($r);
         }
         $par=`/sbin/zfs get -H -o value keystatus $w[0]`;  chomp($par);

         @f=split(/ +/,$f);
         print "check $w[0], keysource=$r, split=$f[2], keystatus=$par\n\n";

         if (($f[2] =~/[LW]\d:[LW]\d/) && ($r eq "passphrase,prompt") && ($par eq "unavailable")) {
            print "unlock $f[0]\n";
            &this_unlock("$w[0]","$f[2]");     # fs, split
            print "keystatus: ".`/sbin/zfs get -H -o value keystatus $w[0]` ."\n";  ;
         }
     }
}

#restore smb properties like name and abe
foreach my $l (@tt) {

     @w=split(/ +/,$l);


     if ($w[2] eq "yes") {
       $r=`/sbin/zfs set sharesmb=off $w[0]`;    #  off as default
       $r=`/sbin/zfs get -H -o value enc_smbshare: $w[0]`; chomp($r);
       print "smb restore fs? $w[0] $r\n";

       if ($r=~/[a-z]/) {                      # sharesmb=name=data,guestok=true
                   #reshare
                    $t=$r;
                    $t=~s/.*name=//; $t=~s/,.*//;  #keep name

                    if ($t ne "off") {           # do not share with name=off
                                #
                                if ($t eq "on") {
                                  $t="on";
                                } else {
                                  $t="name=$t";
                                }

                                if ($r=~/guest/) { $t.=',guestok=true'; }
                                if ($r=~/abe/)   { $t.=',abe=true'; }

                                $r=`/sbin/zfs set sharesmb=$t $w[0]`;

                     }
       }
     }

}

print "ok\n\n";
exit;

##################
sub this_unlock {  # zfslib_change_property

  my $zfs=$_[0];     # tank/data
  my $pass=$_[1];    # L1:L2
  $in{'zfs'}=$zfs;
  $in{'pass'}=$pass;
  $in{'prop'}="unlock";
  $in{'call'}="boot";
  $in{'remember'}="last";

#&print_hash(%in);

  my $r=&zfslib_change_property;
  print "$r\n\n";
}

###############
sub print_hash { #parameter %
###############
 my %h = @_;
 my ($k,$v,@tmp,$w,$a);

      while (($k,$v) = each %h) {
           $w=$k." "."." x 40;
           $w=substr($w,0,41);
           push (@tmp,"$w -> \'$v\' \n");
      }
      @tmp=sort(@tmp);
      print "\n\&print_hash\n\n";
      foreach my $t (@tmp) {
        print $t;
      }
      exit;
}

1;







